from scipy.special import jn, jn_zeros # importation nécessaire au calcul de la fonction de Bessel
from math import *
import matplotlib.pyplot as plt
import numpy as np

print("")
print("**************************************")
print("*Diffraction dans un télescope       *")
print("*   ECE 5 p. 572                     *")
print("*************************Hatier 2020**")

print("Attention : le séparateur décimal est le point, pas la virgule.")

# Saisie des paramètres métriques du dispositif
ldo=float(input("longueur d onde (en nm) ="))
dia=float(input("diamètre de la pupille (en mm) ="))
dis=float(input("distance trou-écran (en m) ="))

plt.xlim(-6,6)
plt.ylim(0,1)
plt.grid(True)
plt.title("I en fonction de X (en mm)")
X=np.linspace(-6.01,6,200)
# jn(1,x) est une fonction de Bessel
plt.plot(X,(2*jn(1,3141.59*dia*X/(ldo*dis))/(3141.59*dia*X/(ldo*dis)))**2)
plt.show()
